CREATE OR REPLACE PROCEDURE GERA_REL_CONCCAIXA(P_NRSEQCONCTEMP IN VARCHAR2,
   P_CDEMPRESA IN VARCHAR2,
   P_DATAINICIAL IN BAIXARECEBIDA.DTBAIXAREC%TYPE,
   P_DATAFINAL IN BAIXAPAGA.DTBAIXAPAG%TYPE)IS

   V_COUNT  INTEGER;
   V_NRPAGINA  INTEGER;
   V_CDCLASSFINA VARCHAR2(10);
   V_DSCLASSFINA  VARCHAR2(40);
   V_IDCONTA  VARCHAR2(20);
   V_VALOR FLOAT;
   V_NRMES FLOAT;
   V_VALOR1 FLOAT;
   V_VALOR2 FLOAT;
   V_VALOR3 FLOAT;
   V_NMMES VARCHAR2(10);
   V_ACHOUVALOR BOOLEAN;


	PROCEDURE BUSCARECEITAS(P_CDEMPRESA IN VARCHAR2, P_DTINICIAL IN DATE, P_DTFINAL IN DATE)	IS
	BEGIN
		V_ACHOUVALOR := FALSE;
	   FOR C_VALORES IN(SELECT REC.CDCLASSFINA, DSCLASSFINA, '1' AS IDCONTA, NVL(SUM(VRFINALBOL),0) VALOR
                        FROM (SELECT CDCLASSFINA, SUM(ROUND(CR.VRATUAREC, 2) + ((BO.VRFINALBREC - BO.VRBOLREC) * (CR.VRATUAREC/(DECODE(BO.VRBOLREC, 0, 1, BO.VRBOLREC))))) VRFINALBOL
                                FROM BOLETRECEBER BO, BAIXARECEBIDA BX,CONTARECEBER CR
                               WHERE BX.CDEMPRESA = P_CDEMPRESA
                                 AND BO.NRBAIXAREC = BX.NRBAIXAREC
                                 AND BO.CDFILIBAIREC = BX.CDFILIAL
                                 AND BX.DTBAIXAREC BETWEEN P_DTINICIAL AND P_DTFINAL
                                 AND CR.CDFILIBOLREC = BO.CDFILIAL
                                 AND CR.NRLANBOLREC = BO.NRLANBOLREC
                               GROUP BY CDCLASSFINA) REC, CLASSFINANC CL
                        WHERE REC.CDCLASSFINA = CL.CDCLASSFINA
                        GROUP BY REC.CDCLASSFINA, DSCLASSFINA ) LOOP

			INSERT INTO CONCCAIXA_TEMP
           (NRSEQCONCTEMP, CDEMPRESA, CDMOVI, DSMOVI, IDENT, VRMOVI, IDPERIODO)
		   VALUES
           (P_NRSEQCONCTEMP, P_CDEMPRESA,C_VALORES.CDCLASSFINA,C_VALORES.DSCLASSFINA,C_VALORES.IDCONTA, C_VALORES.VALOR, V_NMMES);
		   V_ACHOUVALOR := TRUE;

		END LOOP;
      IF NOT (V_ACHOUVALOR) THEN
         INSERT INTO CONCCAIXA_TEMP
           (NRSEQCONCTEMP, CDEMPRESA, CDMOVI, DSMOVI, IDENT, VRMOVI, IDPERIODO)
         VALUES
           (P_NRSEQCONCTEMP, P_CDEMPRESA,'','','1', 0, V_NMMES);
      END IF;
	END;

	PROCEDURE BUSCAOUTRASENTRADAS(P_CDEMPRESA IN VARCHAR2, P_DTINICIAL IN DATE, P_DTFINAL IN DATE)	IS
	BEGIN
		V_ACHOUVALOR := FALSE;
	   FOR C_VALORES IN(SELECT TP.CDTPCREDBANC, TP.DSTPCREDBANC, '2' AS IDCONTA, SUM(VRMOVBANC) VALOR
                         FROM MOVBANCARIO M, CONTCORR C, MOVCREDBANC MC, TPCREDBANC TP
                        WHERE IDORIGMBANC = 'C'
                          AND DTMOVBANC BETWEEN P_DTINICIAL AND P_DTFINAL
                          AND M.CDREDUCONT = C.CDREDUCONT
                          AND M.NRMOVBANC = MC.NRMOVBANC
                          AND M.CDREDUCONT = MC.CDREDUCONT
                          AND C.CDEMPRESA = P_CDEMPRESA
                          AND MC.CDTPCREDBANC = TP.CDTPCREDBANC
                        GROUP BY TP.CDTPCREDBANC, TP.DSTPCREDBANC, '2'
                        ORDER BY TP.DSTPCREDBANC ) LOOP

			INSERT INTO CONCCAIXA_TEMP
           (NRSEQCONCTEMP, CDEMPRESA, CDMOVI, DSMOVI, IDENT, VRMOVI, IDPERIODO) 
		   VALUES
           (P_NRSEQCONCTEMP, P_CDEMPRESA,C_VALORES.CDTPCREDBANC,C_VALORES.DSTPCREDBANC,C_VALORES.IDCONTA, C_VALORES.VALOR, V_NMMES);
			V_ACHOUVALOR := TRUE;
		END LOOP;
		IF NOT (V_ACHOUVALOR) THEN
			INSERT INTO CONCCAIXA_TEMP
           (NRSEQCONCTEMP, CDEMPRESA, CDMOVI, DSMOVI, IDENT, VRMOVI, IDPERIODO)
			VALUES
           (P_NRSEQCONCTEMP, P_CDEMPRESA,'','','2', 0, V_NMMES);
		END IF;
	END;

	PROCEDURE BUSCADESPESAS(P_CDEMPRESA IN VARCHAR2, P_DTINICIAL IN DATE, P_DTFINAL IN DATE)	IS
	BEGIN
		V_ACHOUVALOR := FALSE;
	   FOR C_VALORES IN(
		  SELECT PAG.CDCLASSFINA, DSCLASSFINA, '3' AS IDCONTA, NVL(SUM(VRFINALBOL),0) VALOR
			 FROM (SELECT CDCLASSFINA, SUM(ROUND(CP.VRATUAPAG, 2) + ((BP.VRFINALBPAG - BP.VRBOLPAG) * (CP.VRATUAPAG/(DECODE(BP.VRBOLPAG, 0, 1, BP.VRBOLPAG))))) VRFINALBOL
                  FROM BOLETPAGAR BP, BAIXAPAGA BX,CONTAPAGAR CP
                 WHERE BX.CDEMPRESA = P_CDEMPRESA
                   AND BP.NRBAIXAPAG = BX.NRBAIXAPAG
                   AND BP.CDFILIBAIPAG = BX.CDFILIAL
                   AND BX.DTBAIXAPAG BETWEEN P_DTINICIAL AND P_DTFINAL
                   AND CP.CDFILIBPAG = BP.CDFILIAL
                   AND CP.NRLANBOLPAG = BP.NRLANBOLPAG
                  GROUP BY CDCLASSFINA) PAG,CLASSFINANC CL
         WHERE PAG.CDCLASSFINA = CL.CDCLASSFINA
         GROUP BY PAG.CDCLASSFINA, DSCLASSFINA ) LOOP

			V_ACHOUVALOR := TRUE;
			INSERT INTO CONCCAIXA_TEMP
           (NRSEQCONCTEMP, CDEMPRESA, CDMOVI, DSMOVI, IDENT, VRMOVI, IDPERIODO)
		   VALUES
           (P_NRSEQCONCTEMP, P_CDEMPRESA,C_VALORES.CDCLASSFINA,C_VALORES.DSCLASSFINA,C_VALORES.IDCONTA, C_VALORES.VALOR, V_NMMES);
		END LOOP;

		IF NOT (V_ACHOUVALOR) THEN
			INSERT INTO CONCCAIXA_TEMP
			  (NRSEQCONCTEMP, CDEMPRESA, CDMOVI, DSMOVI, IDENT, VRMOVI, IDPERIODO)
			VALUES
			  (P_NRSEQCONCTEMP, P_CDEMPRESA,'','','3', 0, V_NMMES);
		END IF;
	END;

	PROCEDURE BUSCAOUTRASSAIDAS(P_CDEMPRESA IN VARCHAR2, P_DTINICIAL IN DATE, P_DTFINAL IN DATE)	IS
	BEGIN
		V_ACHOUVALOR := FALSE;
	   FOR C_VALORES IN(SELECT TP.CDTPDEBIBANC, TP.DSTPDEBIBANC, '4' AS IDCONTA, SUM(VRMOVBANC) VALOR
                         FROM MOVBANCARIO M, CONTCORR C, MOVDEBBANC MC, TPDEBIBANC TP
                        WHERE IDORIGMBANC = 'D'
                          AND DTMOVBANC BETWEEN P_DTINICIAL AND P_DTFINAL
                          AND M.CDREDUCONT = C.CDREDUCONT
                          AND M.NRMOVBANC = MC.NRMOVBANC
                          AND M.CDREDUCONT = MC.CDREDUCONT
                          AND C.CDEMPRESA = P_CDEMPRESA
                          AND MC.CDTPDEBIBANC = TP.CDTPDEBIBANC
                        GROUP BY TP.CDTPDEBIBANC, TP.DSTPDEBIBANC, '4'
                        ORDER BY TP.DSTPDEBIBANC) LOOP

			INSERT INTO CONCCAIXA_TEMP
           (NRSEQCONCTEMP, CDEMPRESA, CDMOVI, DSMOVI, IDENT, VRMOVI, IDPERIODO)
		   VALUES
           (P_NRSEQCONCTEMP, P_CDEMPRESA,C_VALORES.CDTPDEBIBANC,C_VALORES.DSTPDEBIBANC,C_VALORES.IDCONTA, C_VALORES.VALOR, V_NMMES);
			V_ACHOUVALOR := TRUE;
		END LOOP;

		IF NOT (V_ACHOUVALOR) THEN
			INSERT INTO CONCCAIXA_TEMP
           (NRSEQCONCTEMP, CDEMPRESA, CDMOVI, DSMOVI, IDENT, VRMOVI, IDPERIODO)
			VALUES
           (P_NRSEQCONCTEMP, P_CDEMPRESA,'','','4', 0, V_NMMES);
		END IF;	
	END; 	
	
	PROCEDURE BUSCASALDOCIRCULANTE(P_CDEMPRESA IN VARCHAR2, P_DTINICIAL IN DATE, P_DTFINAL IN DATE)	IS
	BEGIN	   
	
		V_ACHOUVALOR := FALSE;		
	   FOR C_VALORES IN(
		
	     SELECT B.CDBANCO,B.NMBANCO, '5' AS IDCONTA, SUM(NVL(VRSDOCCORR,0)) VALOR      
          FROM SDOCCORR SD, CONTCORR CT, BANCO B
          WHERE
              CT.CDEMPRESA = P_CDEMPRESA       AND
              SD.CDREDUCONT  = CT.CDREDUCONT    AND
              CT.CDBANCO = B.CDBANCO AND
              SD.DTSDOCCORR  IN (SELECT  MAX(A.DTSDOCCORR) FROM SDOCCORR A
                                   WHERE A.CDREDUCONT = CT.CDREDUCONT AND
                                         A.DTSDOCCORR <= P_DTFINAL)  AND
              CT.IDTIPOCCORR <> 'L'   AND
				  SD.VRSDOCCORR <> 0
          GROUP BY  B.CDBANCO,B.NMBANCO, '5'
          ORDER BY NMBANCO         
		  
      ) LOOP			
			
			INSERT INTO CONCCAIXA_TEMP
           (NRSEQCONCTEMP, CDEMPRESA, CDMOVI, DSMOVI, IDENT, VRMOVI, IDPERIODO)
		   VALUES
           (P_NRSEQCONCTEMP, P_CDEMPRESA,C_VALORES.CDBANCO,C_VALORES.NMBANCO,C_VALORES.IDCONTA, C_VALORES.VALOR, V_NMMES);
		V_ACHOUVALOR := TRUE;
		END LOOP;

		IF NOT (V_ACHOUVALOR) THEN
			INSERT INTO CONCCAIXA_TEMP
           (NRSEQCONCTEMP, CDEMPRESA, CDMOVI, DSMOVI, IDENT, VRMOVI, IDPERIODO)
			VALUES
           (P_NRSEQCONCTEMP, P_CDEMPRESA,'','','5', 0, V_NMMES);
		END IF;
	END;

	PROCEDURE BUSCASALDOAPLICACAO(P_CDEMPRESA IN VARCHAR2, P_DTINICIAL IN DATE, P_DTFINAL IN DATE)	IS
	BEGIN
      V_ACHOUVALOR := FALSE;
	   FOR C_VALORES IN(

	     SELECT B.CDBANCO,B.NMBANCO, '6' AS IDCONTA, SUM(NVL(VRSDOCCORR,0)) VALOR
          FROM
              SDOCCORR SD,
              CONTCORR CT,
              BANCO B
          WHERE
              CT.CDEMPRESA = P_CDEMPRESA       AND
              SD.CDREDUCONT  = CT.CDREDUCONT    AND
              CT.CDBANCO = B.CDBANCO AND
              SD.DTSDOCCORR  IN (SELECT  MAX(A.DTSDOCCORR) FROM SDOCCORR A
                                   WHERE A.CDREDUCONT = CT.CDREDUCONT AND
                                         A.DTSDOCCORR <= P_DTFINAL)  AND
              CT.IDTIPOCCORR = 'L'   AND
				  SD.VRSDOCCORR <> 0
          GROUP BY  B.CDBANCO,B.NMBANCO, '6'
          ORDER BY NMBANCO

      ) LOOP

			INSERT INTO CONCCAIXA_TEMP
           (NRSEQCONCTEMP, CDEMPRESA, CDMOVI, DSMOVI, IDENT, VRMOVI, IDPERIODO)
		   VALUES
           (P_NRSEQCONCTEMP, P_CDEMPRESA,C_VALORES.CDBANCO,C_VALORES.NMBANCO,C_VALORES.IDCONTA, C_VALORES.VALOR, V_NMMES);
			V_ACHOUVALOR := TRUE;
		END LOOP;

		IF NOT (V_ACHOUVALOR) THEN
			INSERT INTO CONCCAIXA_TEMP
           (NRSEQCONCTEMP, CDEMPRESA, CDMOVI, DSMOVI, IDENT, VRMOVI, IDPERIODO)
			VALUES
           (P_NRSEQCONCTEMP, P_CDEMPRESA,'','','6', 0, V_NMMES);
		END IF;
	END;

	PROCEDURE BUSCASALDOANTCIRCULANTE(P_CDEMPRESA IN VARCHAR2, P_DTINICIAL IN DATE, P_DTFINAL IN DATE)	IS
	BEGIN
		V_ACHOUVALOR := FALSE;
	   FOR C_VALORES IN(
	      SELECT 'SD_ANT_CIRC' AS CODIGO, 'SALDO CIRCULANTE ANTERIOR' AS DESCRICAO, '7' AS IDCONTA, SUM(NVL(VRSDOCCORR,0)) VALOR
           FROM SDOCCORR SD, CONTCORR CT, BANCO B
          WHERE CT.CDEMPRESA = P_CDEMPRESA
            AND SD.CDREDUCONT  = CT.CDREDUCONT
            AND CT.CDBANCO = B.CDBANCO
            AND SD.DTSDOCCORR  IN (SELECT MAX(A.DTSDOCCORR)
                                     FROM SDOCCORR A
                                   WHERE A.CDREDUCONT = CT.CDREDUCONT
                                     AND A.DTSDOCCORR < P_DTINICIAL)
		      AND CT.IDTIPOCCORR <> 'L'
          GROUP BY 'SD_ANT_CIRC', 'SALDO CIRCULANTE ANTERIOR' , '7'
		  
      ) LOOP			
			
			INSERT INTO CONCCAIXA_TEMP
			  (NRSEQCONCTEMP, CDEMPRESA, CDMOVI, DSMOVI, IDENT, VRMOVI, IDPERIODO)
		   VALUES 
			  (P_NRSEQCONCTEMP, P_CDEMPRESA,C_VALORES.CODIGO,C_VALORES.DESCRICAO,C_VALORES.IDCONTA, C_VALORES.VALOR, V_NMMES);			
		     
		V_ACHOUVALOR := TRUE;		
		END LOOP;
		
		IF NOT (V_ACHOUVALOR) THEN
			INSERT INTO CONCCAIXA_TEMP
			  (NRSEQCONCTEMP, CDEMPRESA, CDMOVI, DSMOVI, IDENT, VRMOVI, IDPERIODO)
			VALUES 
			  (P_NRSEQCONCTEMP, P_CDEMPRESA,'','','7', 0, V_NMMES);
		END IF;	
	END; 
	
	PROCEDURE BUSCASALDOANTAPLICACAO(P_CDEMPRESA IN VARCHAR2, P_DTINICIAL IN DATE, P_DTFINAL IN DATE)	IS
	BEGIN	 
		V_ACHOUVALOR := FALSE;			
	   FOR C_VALORES IN(
		
	      SELECT  'SD_ANT_APLIC' AS CODIGO, 'SALDO APLICAO ANTERIOR' AS DESCRICAO, '8' AS IDCONTA, SUM(NVL(VRSDOCCORR,0)) VALOR     
          FROM
              SDOCCORR SD,
              CONTCORR CT,
              BANCO B
          WHERE 
              CT.CDEMPRESA = P_CDEMPRESA       AND
              SD.CDREDUCONT  = CT.CDREDUCONT    AND
              CT.CDBANCO = B.CDBANCO AND
              SD.DTSDOCCORR  IN (SELECT  MAX(A.DTSDOCCORR) FROM SDOCCORR A
                                   WHERE A.CDREDUCONT = CT.CDREDUCONT AND
                                         A.DTSDOCCORR < P_DTINICIAL) AND
		        CT.IDTIPOCCORR = 'L'
                  GROUP BY 'SD_ANT_APLIC', 'SALDO APLICAO ANTERIOR', '8'                 
		  
      ) LOOP			
			
			INSERT INTO CONCCAIXA_TEMP
			  (NRSEQCONCTEMP, CDEMPRESA, CDMOVI, DSMOVI, IDENT, VRMOVI, IDPERIODO)
		   VALUES 
			  (P_NRSEQCONCTEMP, P_CDEMPRESA,C_VALORES.CODIGO,C_VALORES.DESCRICAO,C_VALORES.IDCONTA, C_VALORES.VALOR, V_NMMES);			
		     
			V_ACHOUVALOR := TRUE;		
		END LOOP;
		
		IF NOT (V_ACHOUVALOR) THEN
			INSERT INTO CONCCAIXA_TEMP
			   (NRSEQCONCTEMP, CDEMPRESA, CDMOVI, DSMOVI, IDENT, VRMOVI, IDPERIODO)
			VALUES 
			   (P_NRSEQCONCTEMP, P_CDEMPRESA,'','','8', 0, V_NMMES);
		END IF;	
	END; 
	
	
	PROCEDURE BUSCAMOVFINANCEIRAS(P_CDEMPRESA IN VARCHAR2, P_DTINICIAL IN DATE, P_DTFINAL IN DATE)	IS
	BEGIN	  
		V_ACHOUVALOR := FALSE;			
	   FOR C_VALORES IN(
		 SELECT NVL(SUM(VRSDOCCORR),0) VALOR, 'SD_ANTAP' AS CDCLASSFINA, '(A) - SALDO(MS ANTERIOR)' AS DSCLASSFINA, '4' AS IDCONTA      
          FROM
              SDOCCORR SD,
              CONTCORR CT,
              BANCO B
          WHERE 
              CT.CDEMPRESA = P_CDEMPRESA       AND
              SD.CDREDUCONT  = CT.CDREDUCONT    AND
              CT.CDBANCO = B.CDBANCO AND
              SD.DTSDOCCORR  IN (SELECT  MAX(A.DTSDOCCORR) FROM SDOCCORR A
                                   WHERE A.CDREDUCONT = CT.CDREDUCONT AND
                                         A.DTSDOCCORR <= P_DTINICIAL)
              AND CT.IDTIPOCCORR = 'L'
                  GROUP BY 'SD_ANT', '(A) - SALDO(MS ANTERIOR)', '4'
        UNION
        SELECT NVL(SUM(VRMOVBANC),0)  VALOR, 'APLIC' AS CDCLASSFINA, '(B) - APLICAES' AS DSCLASSFINA, '4' AS IDCONTA      
          FROM MOVBANCARIO M, CONTCORR C
         WHERE M.CDREDUCONT = C.CDREDUCONT 
           AND M.DTMOVBANC BETWEEN P_DTINICIAL AND P_DTFINAL
           AND C.CDEMPRESA = P_CDEMPRESA
           AND M.IDORIGMBANC NOT IN ('P','R')
           AND M.IDMOVBANC = 'C'
           AND C.IDTIPOCCORR = 'L'
           AND M.IDORIGMBANC = 'T'
        UNION
        SELECT NVL(SUM(VRMOVBANC),0)  VALOR, 'RESG' AS CDCLASSFINA, '(C) - RESGATES' AS DSCLASSFINA, '4' AS IDCONTA      
          FROM MOVBANCARIO M, CONTCORR C
         WHERE M.CDREDUCONT = C.CDREDUCONT 
           AND M.DTMOVBANC BETWEEN P_DTINICIAL AND P_DTFINAL
           AND C.CDEMPRESA = P_CDEMPRESA
           AND M.IDORIGMBANC NOT IN ('P','R')
           AND M.IDMOVBANC = 'D'
           AND C.IDTIPOCCORR = 'L'
           AND M.IDORIGMBANC = 'T'
        UNION
        SELECT NVL(SUM(VRSDOCCORR),0) VALOR, 'SD_ATUAL' AS CDCLASSFINA, '(D) - SALDO(MS ATUAL)' AS DSCLASSFINA, '4' AS IDCONTA      
          FROM
              SDOCCORR SD,
              CONTCORR CT,
              BANCO B
          WHERE 
              CT.CDEMPRESA = P_CDEMPRESA       AND
              SD.CDREDUCONT  = CT.CDREDUCONT    AND
              CT.CDBANCO = B.CDBANCO AND
              SD.DTSDOCCORR  IN (SELECT  MAX(A.DTSDOCCORR) FROM SDOCCORR A
                                   WHERE A.CDREDUCONT = CT.CDREDUCONT AND
                                         A.DTSDOCCORR <= P_DTFINAL)
              AND CT.IDTIPOCCORR = 'L'
                  GROUP BY 'SD_ATUAL', '(A) - SALDO(MS ATUAL)', '4' 
        ORDER BY DSCLASSFINA
      ) LOOP
		
			INSERT INTO CONCCAIXA_TEMP
			  (NRSEQCONCTEMP, CDEMPRESA, CDMOVI, DSMOVI, IDENT, VRMOVI, IDPERIODO)
		   VALUES 
			  (P_NRSEQCONCTEMP, P_CDEMPRESA,C_VALORES.CDCLASSFINA,C_VALORES.DSCLASSFINA,C_VALORES.IDCONTA, C_VALORES.VALOR, V_NMMES);
		END LOOP;	
	END;  
	
	PROCEDURE BUSCATOTALRENDIMENTOS(P_CDEMPRESA IN VARCHAR2)	IS	
	BEGIN
	   V_ACHOUVALOR := FALSE;		
		V_VALOR := 0;
		
		FOR C_MOV IN (SELECT NVL(VRMOVI,0) VRMOVI, CDMOVI
			FROM CONCCAIXA_TEMP
			  WHERE NRSEQCONCTEMP = P_NRSEQCONCTEMP
				 AND CDEMPRESA = P_CDEMPRESA
  				 AND IDENT = '4'
		  ORDER BY CDMOVI
		)LOOP
		
			CASE C_MOV.CDMOVI
				WHEN 'SD_ANTAP' THEN
				  V_VALOR := V_VALOR + C_MOV.VRMOVI * -1;  				
				WHEN 'APLIC' THEN
				  V_VALOR := V_VALOR + C_MOV.VRMOVI * -1;  
				WHEN 'RESG' THEN
				  V_VALOR := V_VALOR + C_MOV.VRMOVI;  
				ELSE
				  V_VALOR := V_VALOR + C_MOV.VRMOVI; 
			END CASE;
	  END LOOP;		
	  
	  UPDATE CONCCAIXA_TEMP
		  SET VRREND  = V_VALOR
	   WHERE NRSEQCONCTEMP = P_NRSEQCONCTEMP
		  AND CDEMPRESA = P_CDEMPRESA
		  AND IDENT = '4';		  
	END;
		
	PROCEDURE BUSCASOMATORIO(P_CDEMPRESA IN VARCHAR2)	IS
	BEGIN 
		BEGIN
			SELECT NVL(SUM(VRMOVI),0) 
			INTO V_VALOR
			FROM CONCCAIXA_TEMP
		  WHERE NRSEQCONCTEMP = P_NRSEQCONCTEMP
			 AND CDEMPRESA = P_CDEMPRESA
			 AND IDENT = '1';
		EXCEPTION
		WHEN NO_DATA_FOUND THEN
			V_VALOR := 0;
		END; 
		INSERT INTO CONCCAIXA_TEMP(NRSEQCONCTEMP, CDEMPRESA, CDMOVI, DSMOVI, IDENT, VRMOVI, IDCONC)
	   VALUES (P_NRSEQCONCTEMP, P_CDEMPRESA, '1_REC','Total de Receitas(1)','9', V_VALOR,'1');		
						
		BEGIN
			SELECT NVL(SUM(VRMOVI),0) 
			  INTO V_VALOR
			  FROM CONCCAIXA_TEMP
			 WHERE NRSEQCONCTEMP = P_NRSEQCONCTEMP
				AND CDEMPRESA = P_CDEMPRESA
				AND IDENT = '2';
		EXCEPTION
		WHEN NO_DATA_FOUND THEN
			V_VALOR := 0;
		END;
		INSERT INTO CONCCAIXA_TEMP(NRSEQCONCTEMP, CDEMPRESA, CDMOVI, DSMOVI, IDENT, VRMOVI, IDCONC)
	   VALUES (P_NRSEQCONCTEMP, P_CDEMPRESA, '2_OUT_ENTR','Total de Outras Entradas (2)','9', V_VALOR,'1');
		
		BEGIN	
			SELECT NVL(SUM(VRMOVI),0) 
			INTO V_VALOR
			FROM CONCCAIXA_TEMP
		  WHERE NRSEQCONCTEMP = P_NRSEQCONCTEMP
			 AND CDEMPRESA = P_CDEMPRESA
			 AND IDENT = '3';
		 EXCEPTION
		WHEN NO_DATA_FOUND THEN
			V_VALOR := 0;
		END;		 
		INSERT INTO CONCCAIXA_TEMP(NRSEQCONCTEMP, CDEMPRESA, CDMOVI, DSMOVI, IDENT, VRMOVI, IDCONC)
	   VALUES (P_NRSEQCONCTEMP, P_CDEMPRESA, '3_DESP','Total de Despesas (3)','9', V_VALOR,'1'); 	
		
		BEGIN
			SELECT NVL(SUM(VRMOVI),0) 
			  INTO V_VALOR
			  FROM CONCCAIXA_TEMP
			 WHERE NRSEQCONCTEMP = P_NRSEQCONCTEMP
				AND CDEMPRESA = P_CDEMPRESA
				AND IDENT = '4';
		EXCEPTION
		WHEN NO_DATA_FOUND THEN
			V_VALOR := 0;
		END;		 		 
		INSERT INTO CONCCAIXA_TEMP(NRSEQCONCTEMP, CDEMPRESA, CDMOVI, DSMOVI, IDENT, VRMOVI, IDCONC)
	   VALUES (P_NRSEQCONCTEMP, P_CDEMPRESA, '4_OUT_SAID','Total de Outras Sadas (4)','9', V_VALOR,'1');	
		
		BEGIN
			SELECT NVL(SUM(VRMOVI),0) 
			INTO V_VALOR
			FROM CONCCAIXA_TEMP
		  WHERE NRSEQCONCTEMP = P_NRSEQCONCTEMP
			 AND CDEMPRESA = P_CDEMPRESA
			 AND IDENT = '5';
		EXCEPTION
		WHEN NO_DATA_FOUND THEN
			V_VALOR := 0;
		END; 
		INSERT INTO CONCCAIXA_TEMP(NRSEQCONCTEMP, CDEMPRESA, CDMOVI, DSMOVI, IDENT, VRMOVI, IDCONC)
	   VALUES (P_NRSEQCONCTEMP, P_CDEMPRESA, '5_SD_CIRC','Saldo Atual das Contas Correntes - Circulante (5)','9', V_VALOR,2);
		
		BEGIN
			SELECT NVL(SUM(VRMOVI),0) 
			INTO V_VALOR
			FROM CONCCAIXA_TEMP
		  WHERE NRSEQCONCTEMP = P_NRSEQCONCTEMP
			 AND CDEMPRESA = P_CDEMPRESA
			 AND IDENT = '6';
		EXCEPTION
		WHEN NO_DATA_FOUND THEN
			V_VALOR := 0;
		END; 
		INSERT INTO CONCCAIXA_TEMP(NRSEQCONCTEMP, CDEMPRESA, CDMOVI, DSMOVI, IDENT, VRMOVI, IDCONC)
	   VALUES (P_NRSEQCONCTEMP, P_CDEMPRESA, '6_SD_APLI','Saldo Atual das Contas Correntes - Aplicao (6)','9', V_VALOR,2);
		
		BEGIN
			SELECT NVL(SUM(VRMOVI),0) 
			INTO V_VALOR
			FROM CONCCAIXA_TEMP
		  WHERE NRSEQCONCTEMP = P_NRSEQCONCTEMP
			 AND CDEMPRESA = P_CDEMPRESA
			 AND IDENT = '7';
		EXCEPTION
		WHEN NO_DATA_FOUND THEN
			V_VALOR := 0;
		END; 
		INSERT INTO CONCCAIXA_TEMP(NRSEQCONCTEMP, CDEMPRESA, CDMOVI, DSMOVI, IDENT, VRMOVI, IDCONC)
	   VALUES (P_NRSEQCONCTEMP, P_CDEMPRESA, '7_SD_ANT_CIRC','Saldo ms anterior das Contas Correntes - Circulante (7)','9', V_VALOR,2);
		
		BEGIN
			SELECT NVL(SUM(VRMOVI),0) 
			INTO V_VALOR
			FROM CONCCAIXA_TEMP
		  WHERE NRSEQCONCTEMP = P_NRSEQCONCTEMP
			 AND CDEMPRESA = P_CDEMPRESA
			 AND IDENT = '8';
		EXCEPTION
		WHEN NO_DATA_FOUND THEN
			V_VALOR := 0;
		END; 
		INSERT INTO CONCCAIXA_TEMP(NRSEQCONCTEMP, CDEMPRESA, CDMOVI, DSMOVI, IDENT, VRMOVI, IDCONC)
	   VALUES (P_NRSEQCONCTEMP, P_CDEMPRESA, '8_SD_ANT_CIRC','Saldo ms anterior das Contas Correntes - Aplicao (8)','9', V_VALOR,2);
	END;  	
	
	PROCEDURE BUSCASOMACONCILIA(P_CDEMPRESA IN VARCHAR2)	IS
	BEGIN  
       
		 V_VALOR := 0;
	 
		FOR C_MOV IN (SELECT NVL(VRMOVI,0) VALOR, CDMOVI
							 FROM CONCCAIXA_TEMP
							WHERE NRSEQCONCTEMP = P_NRSEQCONCTEMP
							 AND CDEMPRESA = P_CDEMPRESA
							 AND IDENT = '6'
							ORDER BY DSMOVI
						 )LOOP
			
				IF(C_MOV.CDMOVI IN ('DESP_M','OUT_SAID','CHE_N','REC_AT')) THEN 
					V_VALOR := V_VALOR + (C_MOV.VALOR * -1);  	
				ELSE
					V_VALOR := V_VALOR + C_MOV.VALOR;  
				END IF;  
	   END LOOP;
	  
		UPDATE CONCCAIXA_TEMP
		  SET VRTOTALCONC  = V_VALOR		     
		WHERE NRSEQCONCTEMP = P_NRSEQCONCTEMP
		  AND CDEMPRESA = P_CDEMPRESA
		  AND IDENT = '6';	 
	END;

BEGIN  

	FOR C_EMPRESA IN(
      SELECT CDEMPRESA
   	    FROM EMPRESA
	   WHERE (INSTR(P_CDEMPRESA, CDEMPRESA) > 0) OR (P_CDEMPRESA = 'T')
	   ORDER BY CDEMPRESA
   )
   LOOP
		V_NRPAGINA := 1; V_NRMES := 0;
		SELECT NMMES
		  INTO V_NMMES
		  FROM (SELECT SUBSTR(TO_CHAR(DTMES, 'MONTH','NLS_DATE_LANGUAGE =''BRAZILIAN PORTUGUESE'''), 1, 3)
                || ' / ' ||TO_CHAR(DTDATA, 'YY') NMMES
               FROM DATA D

       WHERE DTDATA = P_DATAINICIAL);

		BUSCARECEITAS(C_EMPRESA.CDEMPRESA, P_DATAINICIAL,P_DATAFINAL);
		BUSCADESPESAS(C_EMPRESA.CDEMPRESA, P_DATAINICIAL, P_DATAFINAL);
		BUSCAOUTRASENTRADAS(C_EMPRESA.CDEMPRESA,P_DATAINICIAL, P_DATAFINAL);
		BUSCAOUTRASSAIDAS(C_EMPRESA.CDEMPRESA,P_DATAINICIAL, P_DATAFINAL);
      BUSCASALDOCIRCULANTE(C_EMPRESA.CDEMPRESA,P_DATAINICIAL, P_DATAFINAL);
		BUSCASALDOAPLICACAO(C_EMPRESA.CDEMPRESA,P_DATAINICIAL, P_DATAFINAL);
		BUSCASALDOANTCIRCULANTE(C_EMPRESA.CDEMPRESA,P_DATAINICIAL, P_DATAFINAL);
		BUSCASALDOANTAPLICACAO(C_EMPRESA.CDEMPRESA,P_DATAINICIAL, P_DATAFINAL);
		BUSCASOMATORIO(C_EMPRESA.CDEMPRESA);
	END LOOP; -- FIM DO LOOP EMPRESA
	COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('GERA_REL_CONCCAIXA','6.05.000'); END;
/

