/*----------------------------------------------+
|				                |
|     Trigger: DTULTATU_ATRIBEXTRADIME          |  
|     Tabela : ATRIBEXTRADIME                   |
|                                               |
|     Criao:                                  |
|     30/04/2008 - Leandro Corra Gonalves     |
|                                               |
+*/


IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_ATRIBEXTRADIME'and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_ATRIBEXTRADIME
GO

CREATE TRIGGER DTULTATU_ATRIBEXTRADIME
ON ATRIBEXTRADIME 
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 < (SELECT COUNT(*) FROM DELETED)) BEGIN 
   INSERT INTO DELETECACHE (NMTABLECACHE, DSKEYCACHE, DTULTATUCACH)
                            (SELECT 'ATRIBEXTRADIME', 'NRSEQUEDIME=' + NRSEQUEDIME +
                                   ';CDATRIBEXTRDIME=' + CDATRIBEXTRDIME + ';',GETDATE() FROM DELETED)
   
   END
   ELSE BEGIN
      UPDATE ATRIBEXTRADIME
      SET DTULTATUATRIBEX = GETDATE()
      FROM INSERTED
      WHERE  (ISNULL(ATRIBEXTRADIME.NRSEQUEDIME,0)      = ISNULL(INSERTED.NRSEQUEDIME,0))  AND	
             (ISNULL(ATRIBEXTRADIME.CDATRIBEXTRDIME ,0) = ISNULL(INSERTED.CDATRIBEXTRDIME ,0))
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_ATRIBEXTRADIME','5.03.009';
GO
